"use strict";
// Copyright (c) Matthias Hochsteger
// Distributed under the terms of the Modified BSD License.
Object.defineProperty(exports, "__esModule", { value: true });
const base_1 = require("@jupyter-widgets/base");
const scene_1 = require("./scene");
class NGSolveDocuView extends base_1.DOMWidgetView {
    render() {
        console.log("Render NGSDocuView");
        let files = this.model.get("value");
        console.log("data", files);
        let container = document.createElement('div');
        container.setAttribute("style", "height: 50vw;");
        let img = document.createElement('img');
        img.setAttribute("src", files['preview']);
        img.setAttribute("style", "width: 100%");
        img.onclick = (el) => this.onClickImage(el);
        container.appendChild(img);
        this.el.appendChild(container);
        this.model.on('change:value', this.data_changed, this);
    }
    onClickImage(el) {
        console.log("clicked image", el);
        document.body.style.cursor = "wait";
        let files = this.model.get("value");
        $.get(files['render_data'], (render_data) => {
            document.body.style.cursor = "";
            console.log("this el", this);
            let pel = this.el.children[0];
            pel.innerHTML = "";
            console.log("got render data", render_data);
            let scene = new scene_1.Scene();
            scene.init(pel, render_data, { preserveDrawingBuffer: true });
        });
    }
    data_changed() {
        let render_data = this.model.get("value");
        console.log("got new render data", render_data);
        // this.scene.updateRenderData(render_data);
    }
}
exports.NGSolveDocuView = NGSolveDocuView;
//# sourceMappingURL=widget_docu.js.map